diff --git a/modules/RT-STM32L476RG-NUCLEO64/Makefile b/modules/RT-STM32L476RG-NUCLEO64/Makefile
index ef574f5..bbf57ef 100644
--- a/modules/RT-STM32L476RG-NUCLEO64/Makefile
+++ b/modules/RT-STM32L476RG-NUCLEO64/Makefile
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -119,12 +119,13 @@ PROJECT := $(patsubst $(abspath $(dir $(abspath $(lastword $(MAKEFILE_LIST))))..
 include ../../kernel/kernel.mk
 CHIBIOS := $(AMIROOS_KERNEL)
 AMIROOS = ../..
+# Licensing files
+include $(CHIBIOS)/os/license/license.mk
 # Startup files
 include $(CHIBIOS)/os/common/startup/ARMCMx/compilers/GCC/mk/startup_stm32l4xx.mk
 # HAL-OSAL files
 include $(CHIBIOS)/os/hal/hal.mk
 include $(CHIBIOS)/os/hal/ports/STM32/STM32L4xx/platform.mk
-include ./board.mk
 include $(CHIBIOS)/os/hal/osal/rt/osal.mk
 # RTOS files
 include $(CHIBIOS)/os/rt/rt.mk
@@ -132,6 +133,7 @@ include $(CHIBIOS)/os/common/ports/ARMCMx/compilers/GCC/mk/port_v7m.mk
 # Other files (optional).
 include $(CHIBIOS)/test/lib/test.mk
 include $(CHIBIOS)/test/rt/rt_test.mk
+include $(CHIBIOS)/test/oslib/oslib_test.mk
 # AMiRo-BLT files
 include ../../bootloader/bootloader.mk
 # AMiRo-LLD files
@@ -142,17 +144,17 @@ include $(AMIROOS)/core/core.mk
 include $(AMIROOS)/unittests/unittests.mk
 
 # Define linker script file here
-LDSCRIPT= $(BOARDLD)/STM32L476xG.ld
+LDSCRIPT= STM32L476xG.ld
 
 # C sources that can be compiled in ARM or THUMB mode depending on the global
 # setting.
-CSRC = $(STARTUPSRC) \
+CSRC = $(LICSRC) \
+       $(STARTUPSRC) \
        $(KERNSRC) \
        $(PORTSRC) \
        $(OSALSRC) \
        $(HALSRC) \
        $(PLATFORMSRC) \
-       $(BOARDSRC) \
        $(MODULESCSRC) \
        $(TESTSRC) \
        $(PERIPHERYLLDCSRC) \
@@ -161,12 +163,14 @@ CSRC = $(STARTUPSRC) \
        $(CHIBIOS)/os/various/evtimer.c \
        $(CHIBIOS)/os/various/syscalls.c \
        $(CHIBIOS)/os/hal/lib/streams/chprintf.c \
+       board.c \
        module.c \
        $(APPSCSRC)
 
 # C++ sources that can be compiled in ARM or THUMB mode depending on the global
 # setting.
 CPPSRC = $(AMIROOSCORECPPSRC) \
+         $(CHIBIOS)/os/various/cpp_wrappers/syscalls_cpp.cpp \
          $(APPSCPPSRC)
 
 # C sources to be compiled in ARM mode regardless of the global setting.
@@ -196,14 +200,13 @@ ASMXSRC = $(STARTUPASM) \
           $(OSALASM) \
           $(APPSASMXSRC)
 
-INCDIR = $(CHIBIOS)/os/license \
+INCDIR = $(LICINC) \
          $(STARTUPINC) \
          $(KERNINC) \
          $(PORTINC) \
          $(OSALINC) \
          $(HALINC) \
          $(PLATFORMINC) \
-         $(BOARDINC) \
          $(MODULESINC) \
          $(TESTINC) \
          $(BOOTLOADERINC) \
@@ -290,8 +293,16 @@ ULIBS +=
 # End of user defines                                                          #
 ################################################################################
 
+################################################################################
+# Start of targets section                                                     #
+#                                                                              #
 
+# all and its dependencies
+BUILDDIR = ./build
 RULESPATH = $(CHIBIOS)/os/common/startup/ARMCMx/compilers/GCC
 include $(RULESPATH)/rules.mk
 
-include ../flash.mk
+#                                                                              #
+# End of targets section                                                       #
+################################################################################
+
diff --git a/modules/RT-STM32L476RG-NUCLEO64/alldconf.h b/modules/RT-STM32L476RG-NUCLEO64/alldconf.h
index 68a961c..52e1837 100644
--- a/modules/RT-STM32L476RG-NUCLEO64/alldconf.h
+++ b/modules/RT-STM32L476RG-NUCLEO64/alldconf.h
@@ -42,6 +42,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *          By definition time is represented at microsecond precision.
  */
 #define AMIROLLD_CFG_TIME_SIZE          32
+#define AMIROLLD_CFG_USE_MPU6050
 
 #endif /* _ALLDCONF_H_ */
 
diff --git a/modules/RT-STM32L476RG-NUCLEO64/halconf.h b/modules/RT-STM32L476RG-NUCLEO64/halconf.h
index 2ee374c..37ccfc5 100644
--- a/modules/RT-STM32L476RG-NUCLEO64/halconf.h
+++ b/modules/RT-STM32L476RG-NUCLEO64/halconf.h
@@ -86,7 +86,7 @@
  * @brief   Enables the I2C subsystem.
  */
 #if !defined(HAL_USE_I2C) || defined(__DOXYGEN__)
-#define HAL_USE_I2C                         FALSE
+#define HAL_USE_I2C                         TRUE
 #endif
 
 /**
diff --git a/modules/RT-STM32L476RG-NUCLEO64/mcuconf.h b/modules/RT-STM32L476RG-NUCLEO64/mcuconf.h
index 45cbec2..1176a8e 100644
--- a/modules/RT-STM32L476RG-NUCLEO64/mcuconf.h
+++ b/modules/RT-STM32L476RG-NUCLEO64/mcuconf.h
@@ -114,7 +114,7 @@
 #define STM32_ADC_COMPACT_SAMPLES           FALSE
 #define STM32_ADC_USE_ADC1                  FALSE
 #define STM32_ADC_USE_ADC2                  FALSE
-#define STM32_ADC_USE_ADC3                  FALSE
+#define STM32_ADC_USE_ADC3                  TRUE // turned on
 #define STM32_ADC_ADC1_DMA_STREAM           STM32_DMA_STREAM_ID(1, 1)
 #define STM32_ADC_ADC2_DMA_STREAM           STM32_DMA_STREAM_ID(1, 2)
 #define STM32_ADC_ADC3_DMA_STREAM           STM32_DMA_STREAM_ID(1, 3)
@@ -178,7 +178,7 @@
  */
 #define STM32_I2C_USE_I2C1                  FALSE
 #define STM32_I2C_USE_I2C2                  FALSE
-#define STM32_I2C_USE_I2C3                  FALSE
+#define STM32_I2C_USE_I2C3                  TRUE
 #define STM32_I2C_BUSY_TIMEOUT              50
 #define STM32_I2C_I2C1_RX_DMA_STREAM        STM32_DMA_STREAM_ID(1, 7)
 #define STM32_I2C_I2C1_TX_DMA_STREAM        STM32_DMA_STREAM_ID(1, 6)
diff --git a/modules/RT-STM32L476RG-NUCLEO64/module.c b/modules/RT-STM32L476RG-NUCLEO64/module.c
index c3f4d92..c15f57e 100644
--- a/modules/RT-STM32L476RG-NUCLEO64/module.c
+++ b/modules/RT-STM32L476RG-NUCLEO64/module.c
@@ -71,4 +71,36 @@ ROMCONST char* moduleShellPrompt = "STM32L476-DevBoard";
 #endif
 
 
+MPU6050Driver moduleLldMpu6050 = {
+  /* I2C Driver       */ &MODULE_HAL_I2C_MPU6050,
+  /* I²C address      */ 0x68,
+  /* current LSB (uA) */ 0x00u,
+  /* configuration    */ NULL,
+};
+
+/* MPU6050 */
+static int _utShellCmdCb_AlldMpu6050(BaseSequentialStream* stream, int argc, char* argv[])
+{
+  (void)argc;
+  (void)argv;
+  aosUtRun(stream, &moduleUtAlldMpu6050, NULL);
+  return AOS_OK;
+}
+
+static ut_mpu6050data_t _utAlldMpu6050Data = {
+   /* driver */ &moduleLldMpu6050,
+  /* timeout  */ MICROSECONDS_PER_SECOND,
+};
+aos_unittest_t moduleUtAlldMpu6050 = {
+  /* name           */ "MPU6050",
+  /* info           */ "accelerometer and gyroscope",
+  /* test function  */ utAlldMpu6050Func,
+  /* shell command  */ {
+    /* name     */ "unittest:Accelerometer&Gyroscope",
+    /* callback */ _utShellCmdCb_AlldMpu6050,
+    /* next     */ NULL,
+  },
+  /* data           */ &_utAlldMpu6050Data
+};
+
 /** @} */
diff --git a/modules/RT-STM32L476RG-NUCLEO64/module.h b/modules/RT-STM32L476RG-NUCLEO64/module.h
index 5d57ca0..c2f20f0 100644
--- a/modules/RT-STM32L476RG-NUCLEO64/module.h
+++ b/modules/RT-STM32L476RG-NUCLEO64/module.h
@@ -87,6 +87,16 @@ extern CANConfig moduleHalCanConfig;
 #define MODULE_HAL_PROGIF                       SD2
 
 /**
+ * @brief   I2C driver to access multiplexer, proximity sensors 5 to 8, power monitors for VSYS4.2, VIO 5.0 and VDD, EEPROM, touch sensor, and fuel gauge (front battery).
+ */
+#define MODULE_HAL_I2C_MPU6050 I2CD3
+
+/**
+ * @brief   Configuration for the multiplexer, proximity sensors 1 to 4, power monitors for VIO1.8 and VIO 3.3, and fuel gauge (rear battery) I2C driver.
+ */
+extern I2CConfig moduleHalI2cMpu6050Config;
+
+/**
  * @brief   Configuration for the programmer serial interface driver.
  */
 extern SerialConfig moduleHalProgIfConfig;
@@ -197,6 +207,7 @@ extern ROMCONST apalControlGpio_t moduleGpioBtRst;
 
 /** @} */
 
+
 /*===========================================================================*/
 /**
  * @name AMiRo-OS core configurations
@@ -259,6 +270,28 @@ extern ROMCONST apalControlGpio_t moduleGpioBtRst;
 extern ROMCONST char* moduleShellPrompt;
 #endif
 
+/**
+ * @brief   Unit test initialization hook.
+ */
+#define MODULE_INIT_TESTS() {                                                 \
+  /* add unit-test shell commands */                                          \
+  aosShellAddCommand(&aos.shell, &moduleUtAlldMpu6050.shellcmd);              \
+}
+
+#include <alld_mpu6050.h>
+
+/**
+ * @brief   Accelerometer (MPU6050) driver.
+ */
+extern MPU6050Driver moduleLldMpu6050;
+
+#include <ut_alld_mpu6050.h>
+
+/**
+ * @brief   MPU6050 unit test object.
+ */
+extern aos_unittest_t moduleUtAlldMpu6050;
+
 #endif /* _AMIROOS_MODULE_H_ */
 
 /** @} */
diff --git a/modules/aos_chconf.h b/modules/aos_chconf.h
index 6645802..c01d2f9 100644
--- a/modules/aos_chconf.h
+++ b/modules/aos_chconf.h
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/modules/modules.mk b/modules/modules.mk
index b5a1957..7567637 100644
--- a/modules/modules.mk
+++ b/modules/modules.mk
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
diff --git a/periphery-lld/periphAL.h b/periphery-lld/periphAL.h
index e4bfa92..a19dba2 100644
--- a/periphery-lld/periphAL.h
+++ b/periphery-lld/periphAL.h
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/periphery-lld/periphery-lld.mk b/periphery-lld/periphery-lld.mk
index a8eac6c..b8c37eb 100644
--- a/periphery-lld/periphery-lld.mk
+++ b/periphery-lld/periphery-lld.mk
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
diff --git a/periphery-lld/peripherylldsetup.sh b/periphery-lld/peripherylldsetup.sh
index 914470b..ecd28bc 100755
--- a/periphery-lld/peripherylldsetup.sh
+++ b/periphery-lld/peripherylldsetup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -263,6 +263,40 @@ function setLogFile {
   return 0
 }
 
+### check whether commands are available #######################################
+# Checks whether the specified commands are available and can be executed.
+#
+# usage:      checkCommand [<command> <command> ...]
+# arguments:  <command>
+#                 Name of the command to check.
+# return:     0
+#                 All requested commands are available.
+#             >0
+#                 Number of requested commands that were not found.
+#             -1
+#                 No argument given.
+#
+function checkCommands {
+  local status=0
+
+  # return if no argument was specified
+  if [ $# -eq 0 ]; then
+    return -1
+  fi
+
+  # check all specified commands
+  while [ $# -gt 0 ]; do
+    command -v $1 &>/dev/null
+    if [ $? -ne 0 ]; then
+      printWarning "Command '$1' not available.\n"
+      status=$((status + 1))
+    fi
+    shift 1
+  done
+
+  return $status
+}
+
 ################################################################################
 # SPECIFIC FUNCTIONS                                                           #
 ################################################################################
@@ -281,7 +315,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2019  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"
@@ -327,6 +361,8 @@ function printHelp {
 #                 Warning: Arborted by user.
 #             -1
 #                 Error: Unexpected user input.
+#             -2
+#                 Error: Missing dependencies.
 #
 function initAmiroLld {
   printInfo "initializing AMiRo-LLD submodule...\n"
@@ -352,6 +388,13 @@ function initAmiroLld {
     esac
   fi
 
+  # check dependencies
+  checkCommands git
+  if [ $? -ne 0 ]; then
+    printError "Missing dependencies detected.\n"
+    return -2
+  fi
+
   # initialize submodule to default branch
   cd $peripheryllddir
   git submodule update --init $amirollddir 2>&1 | tee -a $LOG_FILE
@@ -381,13 +424,30 @@ function initAmiroLld {
 #
 # usage:      wipeAmiroLld
 # arguments:  n/a
-# return:     n/a
+# return:     0
+#                 No error or warning occurred.
+#             1
+#                 Warning: AMiRo-LLD Git submodule already empty
+#             2
+#                 Warning: Aborted by user.
+#             -1
+#                 Error: Unexpected input occurred.
+#             -2
+#                 Error: Missing dependencies.
+#
 function wipeAmiroLld {
   printInfo "reset and wipe Git submodule $amirollddir\n"
   local userdir=$(pwd)
   local peripheryllddir=$(dirname $(realpath ${BASH_SOURCE[0]}))
   local amirollddir=${peripheryllddir}/AMiRo-LLD
 
+  # check dependencies
+  checkCommands git
+  if [ $? -ne 0 ]; then
+    printError "Missing dependencies detected.\n"
+    return -2
+  fi
+
   # if the AMiRo-LLD folder is empty
   if [ -z "$(ls -A $amirollddir)" ]; then
     printWarning "$amirollddir is already empty\n"
diff --git a/setup.sh b/setup.sh
index 036bdc4..bf8b54b 100755
--- a/setup.sh
+++ b/setup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -263,6 +263,40 @@ function setLogFile {
   return 0
 }
 
+### check whether commands are available #######################################
+# Checks whether the specified commands are available and can be executed.
+#
+# usage:      checkCommand [<command> <command> ...]
+# arguments:  <command>
+#                 Name of the command to check.
+# return:     0
+#                 All requested commands are available.
+#             >0
+#                 Number of requested commands that were not found.
+#             -1
+#                 No argument given.
+#
+function checkCommands {
+  local status=0
+
+  # return if no argument was specified
+  if [ $# -eq 0 ]; then
+    return -1
+  fi
+
+  # check all specified commands
+  while [ $# -gt 0 ]; do
+    command -v $1 &>/dev/null
+    if [ $? -ne 0 ]; then
+      printWarning "Command '$1' not available.\n"
+      status=$((status + 1))
+    fi
+    shift 1
+  done
+
+  return $status
+}
+
 ################################################################################
 # SPECIFIC FUNCTIONS                                                           #
 ################################################################################
@@ -281,7 +315,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2019  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"
